'use strict';

exports.__esModule = true;
exports.getStrategy = getStrategy;

var _feedbackStrategies = require('../enums/feedbackStrategies');

var _isDefined = require('./isDefined');

function getStrategy(context, field) {
  var props = context.props;
  var INSTANT = _feedbackStrategies.feedbackStrategies.INSTANT;
  var INSTANT_CHANGED_ONLY = _feedbackStrategies.feedbackStrategies.INSTANT_CHANGED_ONLY;
  var ON_CHANGE = _feedbackStrategies.feedbackStrategies.ON_CHANGE;
  var ON_SUBMIT = _feedbackStrategies.feedbackStrategies.ON_SUBMIT;


  if ([INSTANT, INSTANT_CHANGED_ONLY].includes(field.feedbackStrategy)) {
    return field.feedbackStrategy;
  }

  if (!(0, _isDefined.isDefined)(field.feedbackStrategy) && [INSTANT, INSTANT_CHANGED_ONLY].includes(props.feedbackStrategy)) {
    return props.feedbackStrategy;
  }

  if (context.formWasSubmitted) {
    return ON_SUBMIT;
  }

  if (context.bluredFields[field.attr]) {
    return ON_CHANGE;
  }

  return field.feedbackStrategy || props.feedbackStrategy || ON_SUBMIT;
}